pmarlen-web/src/main/java/com/pmarlen/web/operation/OperacionesEnAlmacenesMB.java
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.pmarlen.web.operation;

import com.pmarlen.businesslogic.LogicaFinaciera;
import com.pmarlen.businesslogic.PedidoVentaBusinessLogic;
import com.pmarlen.model.Constants;
import com.pmarlen.model.beans.*;
import com.pmarlen.model.controller.PedidoVentaJpaController;
import com.pmarlen.model.controller.ProductoJpaController;
import com.pmarlen.model.dto.MovimientoEntreAlmacenes;
import com.pmarlen.model.dto.ProductoEnTrancito;
import com.pmarlen.web.security.managedbean.SessionUserMB;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.List;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.SelectItem;
import javax.faces.validator.ValidatorException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.springframework.beans.factory.annotation.Autowired;

/**
 *
 * @author VEAXX9M
 */
public class OperacionesEnAlmacenesMB {

	@Autowired
	private ProductoJpaController productoJpaController;
	@Autowired
	private PedidoVentaBusinessLogic pedidoVentaBusinessLogic;
	@Autowired
	private SessionUserMB sessionUserMB;
	private Integer sucursalId;
	private Logger logger;
	private int scrollerPage;

	private List<MovimientoEntreAlmacenes> movimientoEntreAlmacenesList;
	
	public OperacionesEnAlmacenesMB() {
		logger = LoggerFactory.getLogger(PedidosPreVisorMB.class);
		sucursalId = 1;
	}

	public List<SelectItem> getSucursales() {
		List<Sucursal> list = productoJpaController.findAllSucursales();
		List<SelectItem> result = new ArrayList<SelectItem>();
		for (Sucursal s : list) {
			SelectItem sucursalSI = new SelectItem(s.getId(), s.getNombre());
			result.add(sucursalSI);
		}

		return result;
	}

	public List<SelectItem> getSucursalesHijas() {
		List<Sucursal> list = productoJpaController.findAllSucursales();
		List<SelectItem> result = new ArrayList<SelectItem>();
		for (Sucursal s : list) {
			if (s.getSucursal() == null) {
				continue;
			}
			SelectItem sucursalSI = new SelectItem(s.getId(), s.getNombre());
			result.add(sucursalSI);
		}

		return result;
	}

	private void dataValidation() throws ValidatorException {
		logger.debug("\t################################ >> dataValidation: ");
		//logger.debug("\t\t################################ >> throw new ValidatorException Cliente!");
		//throw new ValidatorException(new FacesMessage(FacesMessage.SEVERITY_ERROR, "Debe seleccionar el Cliente !!", "Debe seleccionalr el Cliente !!"));
		//throw new ValidatorException(new FacesMessage(FacesMessage.SEVERITY_ERROR, "Debe seleccionar la Forma de Pago!!", "Debe seleccionalr la Forma de Pago!!"));        
	}

	public String confirmarSurtirAlmacenPrincipal() {
		logger.debug("========================================================>>");
		logger.debug("-->>confirmarSurtirAlmacenPrincipal():");
		logger.debug("========================================================>>");
		try {

			dataValidation();
			try{
				for(MovimientoEntreAlmacenes ma:movimientoEntreAlmacenesList){
					logger.debug("\t-->>MovimientoEntreAlmacenes: Producto ["+ma.getProducto().getId()+"] surtir:"+ma.getDestinoSurtir()+" PV: $"+ma.getDestinoPV());
				}
				pedidoVentaBusinessLogic.movimientoEntreElmacenes(movimientoEntreAlmacenesList, sucursalId, Constants.ALMACEN_PRINCIPAL,sessionUserMB.getUsuarioAuthenticated());

				return null;
            } catch (Exception ex) {
                logger.debug("<<++++++++++++++++++++++++++++++++++++++++++++++++++");
                ex.printStackTrace(System.err);
                logger.debug("Error in MB confirmarSurtirAlmacen:", ex);

                throw new ValidatorException(
                        new FacesMessage(FacesMessage.SEVERITY_ERROR, ex.toString(), ex.toString()));
            } finally {
                
            }
	
        } catch (ValidatorException ve) {
            logger.debug("<<!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            FacesContext.getCurrentInstance().addMessage(
                    null,
                    ve.getFacesMessage());
            return null;
        }
	}

	public void sucursalChanged(ValueChangeEvent event) {
		Integer sucursalChanged = (Integer) event.getNewValue();
		logger.debug("-->> sucursalChanged: sucursalChanged=" + sucursalChanged);
	}

	public List<ProductoEnTrancito> getAllProductosEnTransitoDeSucursal() {
		//List<ProductoEnAlmacenesDetalle> productoEnAlmacenDetalleList = new ArrayList<ProductoEnAlmacenesDetalle>();
		//List<Producto> productoList = productoJpaController.findAllProductoConAlmacenesDeSucursal(sucursalId);
		long t1,t2;
		
		logger.debug("==>> getAllProductosEnTransitoDeSucursal: sucursalId=" + sucursalId);		
		t1 = System.currentTimeMillis();
		List<ProductoEnTrancito> findAllProductosEnTransitoDeSucursal = productoJpaController.findAllProductosEnTransitoDeSucursal(sucursalId);
		t2 = System.currentTimeMillis();
		logger.debug("==>> T = "+(t2-t1));
		return findAllProductosEnTransitoDeSucursal;
		

	}

	public List<MovimientoEntreAlmacenes> getAllMovimientoEntreAlmacenesPrincipal() {
		//List<MovimientoEntreAlmacenes> movimientoEntreAlmacenesList = new ArrayList<MovimientoEntreAlmacenes>();
		//List<Producto> productoList = productoJpaController.findAllProductoConAlmacenesDeSucursal(sucursalId);
		logger.debug("==>> getAllMovimientoEntreAlmacenes: sucursalId=" + sucursalId);
		
		movimientoEntreAlmacenesList = productoJpaController.findAllProductosMovimientoEntreAlmacenesDeSucursal(sucursalId, Constants.ALMACEN_PRINCIPAL);

		return movimientoEntreAlmacenesList;
	}

	public List<MovimientoEntreAlmacenes> getAllMovimientoEntreAlmacenesOportunidad() {
		//List<MovimientoEntreAlmacenes> movimientoEntreAlmacenesList = new ArrayList<MovimientoEntreAlmacenes>();
		//List<Producto> productoList = productoJpaController.findAllProductoConAlmacenesDeSucursal(sucursalId);
		logger.debug("==>> getAllMovimientoEntreAlmacenes: sucursalId=" + sucursalId);

		return productoJpaController.findAllProductosMovimientoEntreAlmacenesDeSucursal(sucursalId, Constants.ALMACEN_OPORTUNIDAD);
	}

	public List<ProductoEnAlmacenesDetalle> getProductosEnAlmacenes() {
		List<ProductoEnAlmacenesDetalle> productoEnAlmacenDetalleList = new ArrayList<ProductoEnAlmacenesDetalle>();
		List<Producto> productoList = productoJpaController.findAllProductoConAlmacenesDeSucursal(sucursalId);
		logger.debug("==>> getProductoConMovimientos: sucursalId=" + sucursalId);

		for (Producto producto : productoList) {
			ProductoEnAlmacenesDetalle productoEnAlmacenDetalle = new ProductoEnAlmacenesDetalle(producto);

			Collection<AlmacenProducto> almacenProductoCollection = producto.getAlmacenProductoCollection();

			logger.debug("\t==>> Producto[" + producto.getId() + "]");
			for (AlmacenProducto ap : almacenProductoCollection) {
				logger.debug("\t\t==>> AlmacenProducto: almacen=" + ap.getAlmacen() + "[" + ap.getAlmacen().getTipoAlmacen() + "],sucursal=" + ap.getAlmacen().getSucursal().getId() + ", cantidad=" + ap.getCantidadActual());
				if (ap.getAlmacen().getSucursal().getId().intValue() == sucursalId) {

					if (ap.getAlmacen().getTipoAlmacen() == Constants.ALMACEN_PRINCIPAL) {
						productoEnAlmacenDetalle.setAlmacenPrincipal(ap);
						logger.debug("\t\t\t==>> OK added");
					} else if (ap.getAlmacen().getTipoAlmacen() == Constants.ALMACEN_OPORTUNIDAD) {
						productoEnAlmacenDetalle.setAlmacenOportunidad(ap);
						logger.debug("\t\t\t==>> OK added");
					}
				}
			}
			productoEnAlmacenDetalleList.add(productoEnAlmacenDetalle);

		}

		return productoEnAlmacenDetalleList;
	}

	public void setSessionUserMB(SessionUserMB sessionUserMB) {
		this.sessionUserMB = sessionUserMB;
	}

	public void setProductoJpaController(ProductoJpaController productoJpaController) {
		this.productoJpaController = productoJpaController;
	}

	/**
	 * @return the sucursal
	 */
	public Integer getSucursalId() {
		return sucursalId;
	}

	/**
	 * @param sucursal the sucursal to set
	 */
	public void setSucursalId(Integer sucursalId) {
		this.sucursalId = sucursalId;
	}

	/**
	 * @param pedidoVentaBusinessLogic the pedidoVentaBusinessLogic to set
	 */
	public void setPedidoVentaBusinessLogic(PedidoVentaBusinessLogic pedidoVentaBusinessLogic) {
		this.pedidoVentaBusinessLogic = pedidoVentaBusinessLogic;
	}

	/**
	 * @return the scrollerPage
	 */
	public int getScrollerPage() {
		return scrollerPage;
	}

	/**
	 * @param scrollerPage the scrollerPage to set
	 */
	public void setScrollerPage(int scrollerPage) {
		this.scrollerPage = scrollerPage;
	}
}

pmarlen-web/src/main/webapp/templates/include/dynamic-css.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:a4j="http://richfaces.org/a4j">
      
	<ui:composition>
	
		<style type="text/css">
			body{
				background-image : url(${facesContext.externalContext.requestContextPath}/images/bg_1.jpg);
				background-repeat: no-repeat;
				background-position:right top;
				background-color:#ffffff;
			}
			
			.label_bold_right {
				display:block; 
				font-weight:bold; 
				text-align:right;
				font-family: Verdana;
				font-size:12px;
			}
			.common_component_bold {
				font-weight:bold; 	
				font-family: Verdana;
				font-size:12px;
			}

			.common_font_component {
				font-family: Verdana;
				font-size:12px;
			}

            .littleLabel_bold_right {
                display:block;
                font-weight:bold;
                text-align:right;
                font-family: Verdana;
                font-size:10px;
            }

            .common_font_littleComponent {
                font-family: Verdana;
                font-size:10px;
            }
		</style>
		
	</ui:composition>
	
</html>

pmarlen-web/src/main/webapp/templates/include/footer.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:a4j="http://richfaces.org/a4j">

    <table cellpadding="0" cellspacing="0" border="0" align="center">
        <tr>
            <td align="center" height="20">
                <a href="http://google.com" style="color:#000; display:block" class="footer-text">
                    [<h:outputText value="#{UIMessages.ENTERPRISE_INFO}"/>]
                </a>
            </td>
        </tr>
        <tr>
            <td align="center">
                <div style="color:#A0A0A0; display:block" class="footer-text">
                    <a href="http://xpressosystems.com">XPRESSO SYSTEMS</a>
                </div>
            </td>
        </tr>
        <tr>
            <td align="center">
                <div style="color:#A0A0A0; display:block" class="footer-text">
                    Construido : #{versionInfo.maven_build_timestamp}
                </div>				
            </td>
        </tr>
    </table>

</html>


pmarlen-web/src/main/webapp/templates/include/header.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<h:form xmlns="http://www.w3.org/1999/xhtml"
        xmlns:c="http://java.sun.com/jsp/jstl/core"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns:rich="http://richfaces.org/rich">

    <table cellpadding="0" cellspacing="0" border="0" width="95%" align="center">
        <tr>
            <td width="100px" height="80" align="center">
                <h:graphicImage id="graphicImageUser3" value="/images/Logo_T1.png" />
            </td>
            <td align="left">
                <h:outputText value="#{UIMessages.MAIN_LEGEND}"      style="font-family: Arial; font-size : 18px;font-weight : bold;"/><br/>
                <h:outputText value="#{UIMessages.MAIN_SYSTEM_NAME}" style="font-family: Arial;font-size : 14px;"/><br/>
                <hr width="95%"/>
                <h:outputText value="#{UIMessages.MENU_LOCATION} : "   style="font-family: Arial;font-size : 10px;"/>
                <ui:insert name="location">
                    #{UIMessages.MENU_LOCATION_PATH}
                </ui:insert>
            </td>

            <td valign="middle" align="right">
				<h:outputText value="#{sessionUserMB.usuarioAuthenticated.nombreCompleto}" 
                                  style="font-family: Arial; font-size : 12px;font-weight : bold;"/>
				|
					<h:outputLink value="${facesContext.externalContext.requestContextPath}/pages/logout.jsf">
                        <h:graphicImage value="/images/door_in.png"/>
                    </h:outputLink>
				<!--
                <rich:panel  bodyClass="rich-laguna-panel-no-header" >

                    <h:outputText value="#{sessionUserMB.usuarioAuthenticated.nombreCompleto}" 
                                  style="font-family: Arial; font-size : 12px;font-weight : bold;"/>        
                    <br/>
                    
                    <a4j:repeat var="perfil" value="#{sessionUserMB.usuarioAuthenticated.perfilCollection}">
                        [<h:graphicImage id="graphicImageUser" value="/images/Perfil_#{perfil.id}_icon.png" title="#{perfil.descripcion}" />]
                    </a4j:repeat>
                    <br/>
                    
                    <h:outputLink value="${facesContext.externalContext.requestContextPath}/pages/logout.jsf">
                        <h:graphicImage value="/images/door_in.png"/>
                    </h:outputLink>
                </rich:panel>
				-->
            </td>
        </tr>

    </table>


</h:form>

pmarlen-web/src/main/webapp/templates/include/header_withMenu.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<h:form xmlns="http://www.w3.org/1999/xhtml"
        xmlns:c="http://java.sun.com/jsp/jstl/core"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns:rich="http://richfaces.org/rich">

    <table cellpadding="0" cellspacing="0" border="0" width="95%" align="center">
        <tr>
            <td width="100px" height="80" align="center">
                <h:graphicImage id="graphicImageUser3" value="/images/Logo_T1.png" />
            </td>
            <td align="left">
                <h:outputText value="#{UIMessages.MAIN_LEGEND}"      style="font-family: Arial; font-size : 18px;font-weight : bold;"/><br/>
                <h:outputText value="#{UIMessages.MAIN_SYSTEM_NAME}" style="font-family: Arial;font-size : 14px;"/><br/>
                <hr width="95%"/>
                <h:outputText value="#{UIMessages.MENU_LOCATION} : "   style="font-family: Arial;font-size : 10px;"/>
                <ui:insert name="location">
                    #{UIMessages.MENU_LOCATION_PATH}
                </ui:insert>
            </td>

            <td valign="middle" align="right">

                <rich:panel  bodyClass="rich-laguna-panel-no-header" >

                    <h:outputText value="#{sessionUserMB.usuarioAuthenticated.nombreCompleto}" 
                                  style="font-family: Arial; font-size : 12px;font-weight : bold;"/>        
                    <br/>
                    <br/>
                    <a4j:repeat var="perfil" value="#{sessionUserMB.usuarioAuthenticated.perfilCollection}">
                        [<h:graphicImage id="graphicImageUser" value="/images/Perfil_#{perfil.id}_icon.png" title="#{perfil.descripcion}" />]
                    </a4j:repeat>

                </rich:panel>

            </td>
        </tr>
        <tr>
            <td colspan="3" height="20">

                <rich:toolBar>

                    <rich:toolBarGroup location="left">
                        <rich:dropDownMenu rendered="#{rich:isUserInRole('sales') or rich:isUserInRole('admin') or rich:isUserInRole('root')}">
                            <f:facet name="label">
                                <h:panelGroup>
                                    <h:graphicImage value="/images/orders.png"/>
                                    <h:outputText value="Operacion"/>
                                </h:panelGroup>
                            </f:facet>

                            <rich:menuItem submitMode="ajax" value="Prod x Industria - Marca" 
                                           action="#{navigationMB.verProductosXIndustriaMarca}" icon="/images/industria_marca_list.png">
                            </rich:menuItem>

                            <rich:menuItem submitMode="ajax" value="Prod x Linea - Marca"
                                           action="#{navigationMB.verProductosXLineaMarca}" icon="/images/linea_marca_list.png">
                            </rich:menuItem>

                            <rich:menuItem submitMode="ajax" value="Productos en carrito"
                                           action="#{navigationMB.pedidoNuevo}" icon="/images/cart.png">
                            </rich:menuItem>

                            <rich:menuItem submitMode="ajax" value="Pedidos de Venta"
                                           action="#{navigationMB.listarPedidosVentas}" icon="/images/order.png">
                            </rich:menuItem>

                        </rich:dropDownMenu>

                        <rich:dropDownMenu rendered="#{rich:isUserInRole('stock') or rich:isUserInRole('admin') or rich:isUserInRole('root')}">
                            <f:facet name="label">
                                <h:panelGroup>
                                    <h:graphicImage value="/images/admin.png"/>
                                    <h:outputText value="Administracion"/>
                                </h:panelGroup>
                            </f:facet>
                            <!--
<rich:menuItem submitMode="ajax" value="Usuarios"
               action="#{navigationMB.listarUsuarios}" icon="/images/users.png">
</rich:menuItem>
                            -->
                            <rich:menuItem submitMode="ajax" value="Productos en Almancenes"
                                           action="#{navigationMB.productosEnAlmacenes}" icon="/images/ico_DataTable.gif">
                            </rich:menuItem>

                        </rich:dropDownMenu>

                    </rich:toolBarGroup>


                    <rich:toolBarGroup location="right">
                        <h:outputLink value="${facesContext.externalContext.requestContextPath}/pages/logout.jsf">
                            <h:graphicImage value="/images/door_in.png"/>
                        </h:outputLink>
                    </rich:toolBarGroup>
                </rich:toolBar>
            </td>
        </tr>

    </table>


</h:form>